# Tests by default. No tests: rpm -ba --define 'dotests 0' *.spec
%{!?dotests: %define dotests 1}

Summary: The GNU patch command, for modifying/upgrading files.
Name: patch
Version:	2.7.6
Release:	3
License: GPLv3+
URL:	https://www.gnu.org/software/patch/patch.html
Group: Development/Tools
Source:	https://ftp.gnu.org/gnu/patch/patch-%{version}.tar.bz2

Patch0:      patch-2.7.6-CVE-2018-1000156.patch
Patch1:      patch-2.7.6-CVE-2018-20969.patch
Patch2:      patch-2.7.6-CVE-2019-13636.patch
Patch3:      patch-2.7.6-CVE-2019-13638.patch 
Patch4:      patch.2.7.6-fix_segfault_with_mangled_rename.patch
Patch5:      patch-2.7.6-test_case.patch
Patch6:      patch-2.7.6-Ulimit_nofiles.patch 


%description
The patch program applies diff files to originals.  The diff command
is used to compare an original to a changed file.  Diff lists the
changes made to the file.  A person who has the original file can then
use the patch command with the diff file to add the changes to their
original file (patching the file).

Patch should be installed because it is a common way of upgrading
applications.

%prep
%setup -q
%patch0 -p1 -b .CVE
%patch1 -p1
%patch2 -p1
%patch3 -p1
%patch4 -p1
%patch5 -p1
%patch6 -p1
 
%build

# Duplicate source for 32 & 64 bits
rm -rf /tmp/%{name}-%{version}-32bit
mkdir  /tmp/%{name}-%{version}-32bit
mv *   /tmp/%{name}-%{version}-32bit
mkdir 32bit
mv     /tmp/%{name}-%{version}-32bit/* 32bit
rm -rf /tmp/%{name}-%{version}-32bit
mkdir 64bit
cp -rp 32bit/* 64bit/

export AR="/usr/bin/ar -X32_64"
# first build the 64-bit version
cd 64bit

export CC="%{__cc__} -maix64 -O2"
export OBJECT_MODE=64

./configure --prefix=%{_prefix} 
make


if [ "%{dotests}" == 1 ]
then
    (gmake -k check || true)
fi

#Now build the 32-bit version
cd ../32bit

export CC="%{__cc__} -maix32 -D_LARGE_FILES -O2"
export OBJECT_MODE=32

./configure --prefix=%{_prefix}
make


if [ "%{dotests}" == 1 ]
then
    (gmake -k check || true)
fi

%install

cd 64bit

make install DESTDIR=$RPM_BUILD_ROOT/
/usr/bin/strip -X64 ${RPM_BUILD_ROOT}%{_bindir}/* || :
(
  cd ${RPM_BUILD_ROOT}%{_bindir}
  for f in patch 
  do
    mv ${f} ${f}_64
  done
)

cd ../32bit
make install DESTDIR=$RPM_BUILD_ROOT/
/usr/bin/strip ${RPM_BUILD_ROOT}%{_bindir}/* || :
(
  cd ${RPM_BUILD_ROOT}%{_bindir}
  for f in patch
  do
    mv ${f} ${f}_32
  done
)

# Make 64bit executable as default
(
  cd ${RPM_BUILD_ROOT}%{_bindir}
  for f in patch
  do
    ln -sf ${f}_64 ${f}
  done
)


%files
%defattr(-,root,system)
%doc 32bit/NEWS 32bit/README
%{_prefix}/bin/*
%{_prefix}/share/man/*/*

%changelog
* Tue Sept 24 2024 Shubham Gupta <Shubham.Gupta36@ibm.com> -2.7.6-4
- fix added for ulimit out of memory error for unlimited noOfFiles

* Tue Feb 20 2024 Harshit K A < harshith.k.a@ibm.com > -2.7.6-2
- Updated to fix the CVE-2018-1000156, CVE-2018-6952, CVE-2018-20969, CVE-2019-20633, CVE-2019-13636, CVE-2018-6951

* Tue Nov 20 2018 Harshita JAin <harjain9@In.ibm.com> -2.7.6-1
- Updated to latest version 2.7.6
* Fri Sep 22 2017 Sushma M Bhat <susmbhat@in.ibm.com> -2.7.5-1
- Built 64 bit and updated to 2.7.5 version

* Fri Mar 23 2001 David Clissold <cliss@austin.ibm.com>
- STDC needed -- default compiler to xlc, not cc

* Thu Mar 08 2001 Marc Stephenson <marc@austin.ibm.com>
- Add logic for default compiler
- Rebuild against new shared objects

* Fri Oct 27 2000 rpmpkg <rpmpkg@austin.ibm.com>
- Adapted for AIX Freeware delivery

* Mon Feb  7 2000 Bill Nottingham <notting@redhat.com>
- handle compressed manpages

* Sun Jun 06 1999 Alan Cox <alan@redhat.com>
- Fix the case where stderr isnt flushed for ask(). Now the 'no such file'
  appears before the skip patch question, not at the very end, Doh!

* Mon Mar 22 1999 Jeff Johnson <jbj@redhat.com>
- (ultra?) sparc was getting large file system support.

* Sun Mar 21 1999 Cristian Gafton <gafton@redhat.com> 
- auto rebuild in the new build environment (release 7)

* Fri Dec 18 1998 Cristian Gafton <gafton@redhat.com>
- build against glibc 2.1

* Tue Sep  1 1998 Jeff Johnson <jbj@redhat.com>
- bump release to preserve newer than back-ported 4.2.

* Tue Jun 09 1998 Prospector System <bugs@redhat.com>
- translations modified for de, fr

* Tue Jun  9 1998 Jeff Johnson <jbj@redhat.com>
- Fix for problem #682 segfault.

* Fri Apr 24 1998 Prospector System <bugs@redhat.com>
- translations modified for de, fr, tr

* Tue Apr 07 1998 Cristian Gafton <gafton@redhat.com>
- added buildroot

* Wed Oct 21 1997 Cristian Gafton <gafton@redhat.com>
- updated to 2.5

* Mon Jun 02 1997 Erik Troan <ewt@redhat.com>
- built against glibc
